//================================================
// RMS - Monster Size Randomizer Mutator by Mr.Loathsome.
//================================================
class RM expands Mutator config(RMS);

var bool bInitialized;
var() config bool bDebugMode;
var() config float MaxMSize;
var() config float MinMSize;

function bool CheckCollision(Actor A, float DSM, vector newLoc)  // Credit to Feralidragon for this function
{
local bool isColliding;
local float CRadius, CHeight;

   CRadius = A.CollisionRadius;
   CHeight = A.CollisionHeight;
   A.SetCollisionSize(A.CollisionRadius * DSM, A.CollisionHeight * DSM);
   isColliding = !A.SetLocation(newLoc);
   A.SetCollisionSize(CRadius, CHeight);
   if (bDebugMode)
   {
       if (isColliding)
          log("RMS: Can NOT grow = "$A$"  DrawScaleMult = "$DSM);
       else
          log("RMS: Can grow = "$A$"  DrawScaleMult = "$DSM);
   }
   return isColliding;
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	local float F;
	local Vector V;

	if (ScriptedPawn(Other) != None)
	{
		if ((Other.DrawScale == Other.default.DrawScale) && (!ScriptedPawn(Other).bIsBoss))
		{
			F = FMax(MinMSize, (FRand()*MaxMSize));
			V = Other.Location;
//			if ((F > 1.0) && (CheckCollision(Other, F, V))) { F = 1.0; }
			if (F > 1.0)
			{
				While ( (F > MinMSize) && (CheckCollision(Other, F, V)) ) 
//					{ F = FMax(MinMSize, F - 0.1250); if (bDebugMode) { log("RMS: Scaledown -> "$F); } }
					{ F = FMax(MinMSize, F - MinMSize); if (bDebugMode) { log("RMS: Scaledown -> "$F); } }
 			}
			Other.DrawScale = Other.DrawScale * F;
			Other.Mass = Other.Mass * F;
			ScriptedPawn(Other).Health = ScriptedPawn(Other).Health * F;
			if ((bDebugMode) && (Other.DrawScale != Other.default.DrawScale))
				{ log("RMS: Monster size randomized.... "$Other$" DrawScale = "$Other.DrawScale); }
		}
		if ((bDebugMode) && (Other.DrawScale == Other.default.DrawScale) && (!ScriptedPawn(Other).bIsBoss))
			{ log("RMS: Monster size NOT randomized.... "$Other$" DrawScale = "$Other.DrawScale); }
		   else
		   	if ((bDebugMode) && (ScriptedPawn(Other).bIsBoss))
				{ log("RMS: Boss Monster size NOT randomized.... "$Other$" DrawScale = "$Other.DrawScale); }
	}
	bSuperRelevant = 0;
	return true;
}

defaultproperties
{
     bDebugMode=False
     MaxMSize=2.0000
     MinMSize=0.2500
}
